package com.heyu.api.alibaba.handle.common.text;

import com.aliyun.ocr20191230.models.RecognizeDriverLicenseRequest;
import com.aliyun.ocr20191230.models.RecognizeDriverLicenseResponse;
import com.aliyun.teautil.models.RuntimeOptions;
import com.heyu.api.data.annotation.CustomPath;
import com.heyu.api.data.utils.StringUtils;
import com.heyu.api.alibaba.AlibabaBaseHandle;
import com.heyu.api.alibaba.request.common.text.ARecognizeDriverLicenseRequest;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;


/**
 * https://next.api.aliyun.com/api/ocr/2019-12-30/RecognizeDriverLicense
 * 驾驶证识别
 */
@Component
@Slf4j
@CustomPath("driverLicense")
public class ARecognizeDriverLicenseHandle extends AlibabaBaseHandle<ARecognizeDriverLicenseRequest, RecognizeDriverLicenseResponse> {

    @Autowired
    private com.aliyun.ocr20191230.Client client;

    @Override
    public String check(ARecognizeDriverLicenseRequest aRecognizeDriverLicenseRequest) {
        String check = checkUrlBase64(aRecognizeDriverLicenseRequest);
        if (check != null) {
            return check;
        }
        if (StringUtils.isBlank(aRecognizeDriverLicenseRequest.side)) {
            return "请上传site字段，face：表示首页，back：表示副页";
        }
        return null;
    }


    @Override
    public RecognizeDriverLicenseResponse run(ARecognizeDriverLicenseRequest arecognizeDriverLicenseRequest, RuntimeOptions runtime) throws Exception {
        RecognizeDriverLicenseRequest request = new RecognizeDriverLicenseRequest();
        request.setImageURL(arecognizeDriverLicenseRequest.getImageUrl());
        request.setSide(arecognizeDriverLicenseRequest.side);
        // 复制代码运行请自行打印 API 的返回值
        return client.recognizeDriverLicenseWithOptions(request, runtime);
    }
}
